searchNodes=[{"doc":"Module exposing various utility functions for interacting with, and introspecting the state of EctoHooks.For more extensive usage instructions, please see associated documentation for EctoHooks.Repo.","ref":"EctoHooks.html","title":"EctoHooks","type":"behaviour"},{"doc":"Alternative interface for initializing EctoHooks when use-ed in a module as follows:def MyApp.Repo do use Ecto.Repo, otp_app: :my_app, adapter: Ecto.Adapters.Postgres use EctoHooks endPlease see EctoHooks.Repo for more information about EctoHooks usage, examples, and considerations.","ref":"EctoHooks.html#__using__/1","title":"EctoHooks.__using__/1","type":"macro"},{"doc":"","ref":"EctoHooks.html#c:after_delete/2","title":"EctoHooks.after_delete/2","type":"callback"},{"doc":"","ref":"EctoHooks.html#c:after_get/2","title":"EctoHooks.after_get/2","type":"callback"},{"doc":"","ref":"EctoHooks.html#c:after_insert/2","title":"EctoHooks.after_insert/2","type":"callback"},{"doc":"","ref":"EctoHooks.html#c:after_update/2","title":"EctoHooks.after_update/2","type":"callback"},{"doc":"","ref":"EctoHooks.html#c:before_delete/1","title":"EctoHooks.before_delete/1","type":"callback"},{"doc":"","ref":"EctoHooks.html#c:before_insert/1","title":"EctoHooks.before_insert/1","type":"callback"},{"doc":"","ref":"EctoHooks.html#c:before_update/1","title":"EctoHooks.before_update/1","type":"callback"},{"doc":"Disables EctoHooks running for all future Repo operations in the current process.Internally, this is called with the options [global: false] which gets automatically cleared after triggering any Ecto.Repo callback.","ref":"EctoHooks.html#disable_hooks/1","title":"EctoHooks.disable_hooks/1","type":"function"},{"doc":"Ensures EctoHooks run for all future Repo operations in the current process.Internally, we use it to scope re-enabling hooks per execution, as we disabled them as a mitigation for infinitely looping hooks caused by hooks triggering other hooks. This happens when provided [global: false], which should only be done internally.","ref":"EctoHooks.html#enable_hooks/1","title":"EctoHooks.enable_hooks/1","type":"function"},{"doc":"Returns a boolean indicating if any before_* or after_* hooks are allowed to execute in the current process.Note that calls to Ecto.Repo callbacks may reset or change the state of this flag, and that this function is primarily exposed for introspection or debugging purposes.","ref":"EctoHooks.html#hooks_enabled?/0","title":"EctoHooks.hooks_enabled?/0","type":"function"},{"doc":"Utility function which returns the &quot;nesting&quot; of the current EctoHooks context.By default, every hook will &quot;acquire&quot; an EctoHook context and increment a ref count. These ref counts are automatically decremented once a hook finishes running.This is provided as a lower level alternative the enable_hooks/1, disable_hooks/1, and hooks_enabled?/0 functions.","ref":"EctoHooks.html#hooks_ref_count/0","title":"EctoHooks.hooks_ref_count/0","type":"function"},{"doc":"Utility function which returns true if currently executing inside the context of an Ecto Hook.","ref":"EctoHooks.html#in_hook?/0","title":"EctoHooks.in_hook?/0","type":"function"},{"doc":"Defines the struct which is given as the 2nd argument to any after_* hooks.Contains metadata which may be useful for introspecting or otherwise conditionally running hooks only when certain conditions are met.The following information is present in an EctoHooks.Delta:The Ecto.Repo callback that triggered the hookThe name of the current hook (useful if delegating to private functions in your schema)The Ecto.Queryable passed into the triggering Ecto.Repo callback if anyThe Ecto.Changeset passed into the triggering Ecto.Repo callback if any","ref":"EctoHooks.Delta.html","title":"EctoHooks.Delta","type":"module"},{"doc":"","ref":"EctoHooks.Delta.html#new!/3","title":"EctoHooks.Delta.new!/3","type":"function"},{"doc":"","ref":"EctoHooks.Delta.html#t:hook/0","title":"EctoHooks.Delta.hook/0","type":"type"},{"doc":"","ref":"EctoHooks.Delta.html#t:repo_callback/0","title":"EctoHooks.Delta.repo_callback/0","type":"type"},{"doc":"","ref":"EctoHooks.Delta.html#t:t/0","title":"EctoHooks.Delta.t/0","type":"type"},{"doc":"Module containing implementation for all after_ hooks","ref":"EctoHooks.Middleware.After.html","title":"EctoHooks.Middleware.After","type":"module"},{"doc":"Module containing implementation for all before_ hooks","ref":"EctoHooks.Middleware.Before.html","title":"EctoHooks.Middleware.Before","type":"module"},{"doc":"This module is intended to replace any usage of use Ecto.Repo. When this is done, any of the following Ecto.Repo callbacks will execute any defined before_* or after_* hooks in your Ecto schemas before returning.Setup and initializationSimply use this module wherever you would use Ecto.Schema. Any provided options are currently forwarded to use Ecto.Repo. In the future, EctoHooks may provide additional functionality based on given options.Example Usage:defmodule MyApp.Repo do use EctoHooks.Repo, otp_app: :my_app, adapter: Ecto.Adapters.Postgres end def MyApp.User do use Ecto.Schema require Logger schema &quot;users&quot; do field :first_name, :string field :last_name, :string field :full_name, :string, virtual: true end def before_insert(changeset) do Logger.warning(&quot;inserted a new user...&quot;) changeset end def after_get(%__MODULE__{} = user, %EctoHooks.Delta{}) do %__MODULE__{user | full_name: user.first_name &lt;&gt; &quot; &quot; &lt;&gt; user.last_name} end endUsageAfter HooksOnce initialized, the following Ecto.Repo callbacks will trigger the listed after_* hooks.Executes after_get/2 if defined in schema:all/2get/3get!/3get_by/3get_by!/3one/2one!/2reload/2reload!/2preload/3Executes after_delete/2 if defined in schema:delete/2delete!/2Executes after_insert/2 if defined in schema:insert/2insert!/2Executes after_update/2 if defined in schema:update/2update!/2Executes after_insert/2 or to after_update/2 if defined in schema:insert_or_update/2insert_or_update!/2Please note that the result of an after_* hook is the result which is intended to be returned by any of the above Ecto.Repo callbacks. All after_* hooks are expected to abide by the following typespec:@spec after_*(schema_struct :: MyApp.User.t(), delta :: EctoHooks.Delta.t()) :: MyApp.User.t()And any Ecto.Repo callback which expects to return {:ok, result} over result will do so automatically.Take care to not break expected Ecto.Repo callback semantics as bugs resulting from these can prove difficult to diagnose and track down. As a rule of thumb, you should always aim to return the same type of argument passed into your defined hooks.Before HooksOnce initialized, the following Ecto.Repo callbacks will trigger the listed before_* hooks.Executes before_delete/1 if defined in schema:delete/2delete!/2Executes before_insert/1 if defined in schema:insert/2insert!/2Executes before_update/1 if defined in schema:update/2update!/2Executes before_insert/1 or to before_update/1 if defined in schema:insert_or_update/2insert_or_update!/2Please note that the result of an before_* hook is usually the Ecto.Queryable which is passed as the first parameter to any of the above Ecto.Repo callbacks. All before_* hooks are expected to abide by the following typespec:@spec before_*(queryable :: Ecto.Queryable.t()) :: Ecto.Queryable.t()ConsiderationsEctoHooks was initially designed to help with centralizing and de-duplicating logic to resolve virtual fields when working with Ecto schemas. However, since EctoHooks allows you to call arbitrary functions in response to Ecto.Repo callbacks, it can be used for much more.All defined hooks are also executed synchronously, immediately before or after calling your Ecto.Repo callback. To try and mitigate the potential for infinite loops caused by hooks triggering other hooks, by default, EctoHooks will only trigger a hook if a parent function in the current process stacktrace is not another hook.As a result, one should take great care when spawning processes which may result in calling Ecto.Repo callbacks, as there is currently no mitigation for infinite loops provided.If you wish to opt in, opt out, or introspect the state of these mitigations, please see the documentation for the following functions: EctoHooks.enable_hooks/1, EctoHooks.disable_hooks/1, EctoHooks.hooks_enabled?/0 and EctoHooks.in_hook?/0.This is a very powerful tool, and admittedly quite hidden and hard to track down. Trying to avoid adding too much business logic in your EctoHooks is wise for both performance reasons (as hooks are executed on every request), and maintainability reasons.","ref":"EctoHooks.Repo.html","title":"EctoHooks.Repo","type":"module"},{"doc":"Enables EctoHooks integration in your Ecto.Repo module when use-ed.","ref":"EctoHooks.Repo.html#__using__/1","title":"EctoHooks.Repo.__using__/1","type":"macro"},{"doc":"This module provides the EctoMiddleware behaviour, which extends any module that uses Ecto.Repo with the capability to hook into the execution of any Ecto.Repo callback (that reads/writes to said repo).Setup and initializationTo enable EctoMiddleware, you must use this module in any of your Ecto.Repo modules.Once done, you will be able to customize the middleware you wish to run either before, or after any given Ecto.Repo callback (again, that reads/writes to said repo).By default, EctoMiddleware will not run any middleware. You must explicitly define them yourself.You're also able to customize the middleware you wish to run based on the given &quot;action&quot; or &quot;resource&quot; that an Ecto.Repo callback is being executed on.The &quot;action&quot; of a given Ecto.Repo callback is the name of the function being executed, without the arity. For example, the &quot;action&quot; of get/3 is get and the &quot;action&quot; of get!/3 is get!.The &quot;resource&quot; of a given Ecto.Repo is typically the first argument of the function being executed. For example, the &quot;resource&quot; of get/3 is a module that uses Ecto.Schema.See the below example:defmodule MyApp.Repo do use Ecto.Repo, otp_app: :my_app, adapter: Ecto.Adapters.Postgres use EctoMiddleware def middleware(action, _resource) when action in [:delete, :delete!] do [MyApp.EctoMiddleware.MaybeSoftDelete, EctoMiddleware.Super, MyApp.EctoMiddleware.Log] end def middleware(_action, _resource) do [EctoMiddleware.Super, MyApp.EctoMiddleware.Log] end endAny middleware preceding EctoMiddleware.Super will be executed before the given Ecto.Repo callback is executed.Any middleware following EctoMiddleware.Super will be executed after the given Ecto.Repo callback is executed.Writing MiddlewareTo write your own middleware, you must implement the EctoMiddleware behaviour in a module of your choosing.The EctoMiddleware behaviour requires you to implement the middleware/2 callback, which takes the &quot;resource&quot; of the given Ecto.Repo callback as the first argument, and an EctoMiddleware.Resolution struct as the second argument.All middleware must return a modified &quot;resource&quot; (or the original &quot;resource&quot; if no modifications were made).Additionally, any configured middleware is run synchronously, in the order they are defined.Please see the EctoMiddleware.Resolution struct for more information, but in short, the struct contains various bits of metadata about the given Ecto.Repo callback that is being executed, the inputs to the callback, and the result of the callback (if it has been executed).Before MiddlewareAny middleware preceding EctoMiddleware.Super will be executed before the given Ecto.Repo callback is executed.Because these middlewares run prior to the Ecto.Repo callback, they are able to modify the inputs to the callback, or even short-circuit the callback entirely, however, they are not able to modify the result of the callback (as it has not been executed yet).If you wish to modify the result of the callback, you must use an after middleware instead.After MiddlewareAny middleware following EctoMiddleware.Super will be executed after the given Ecto.Repo callback is executed.Because these middlewares run after the Ecto.Repo callback, they are able to modify the result of the callback, however, they are not able to modify the inputs to the callback (as it has already been executed).If you wish to modify the inputs to the callback, you must use a before middleware instead.After middleware are additionally able to reference both the result of the callback, and the result of running any before middleware, making it an ideal place to perform any advanced processing or logging.ConsiderationsWhen writing middleware, you should be aware of the following:If you are modifying the &quot;resource&quot; of the given Ecto.Repo callback, you should ensure that the &quot;resource&quot; is still valid for the given Ecto.Repo callback.Middleware are run synchronously, in the order they are defined, and as such, you should be mindful of the performance implications of your middleware.Any middleware that raises an exception will cause the given Ecto.Repo callback to raise an exception as well, regardless of whether or not the given Ecto.Repo callback has been executed or semantically is expected to raise an exception.Middleware may be a place where dialyzer warnings are suppressed, as it may not be possible for dialyzer to infer the types returned out of any given middleware.It is not possible to modify the &quot;action&quot; of the given Ecto.Repo callback, only the &quot;resource&quot;.Ideally, middleware should be written in such a way that they are reusable across multiple Ecto.Repo modules, &quot;actions&quot;, or &quot;resources&quot;. It is not recommended to to write middleware that is too strongly coupled to the prior or future middleware expected to have/be run.Due to how the given Ecto.Repo callback is executed, it is not at this time possible to provide any transactional guarantees for middleware. If you wish to perform any transactional work, you should do so within your application's business logic, and not within any middleware.TestingYou may test your middleware modules in a variety of ways:You can test your middleware modules in the context of your application's business logic, by stubbing any Ecto.Repo callbacks that you wish to test.You can either test your middleware modules in isolation, stubbing any &quot;action&quot; or &quot;resource&quot; that you wish to test.You can directly test them by way of executing the given Ecto.Repo callback against a test database, and asserting on the result.You can use the EctoMiddleware.Resolution.execute_before!/1 and EctoMiddleware.Resolution.execute_after!/2 to directly test middleware.In the future, more work will be done to enable easier testing of individual middleware.","ref":"EctoMiddleware.html","title":"EctoMiddleware","type":"behaviour"},{"doc":"Enables the ability for a given Ecto.Repo to define and execute middleware.","ref":"EctoMiddleware.html#__using__/1","title":"EctoMiddleware.__using__/1","type":"macro"},{"doc":"","ref":"EctoMiddleware.html#c:middleware/2","title":"EctoMiddleware.middleware/2","type":"callback"},{"doc":"Returns the configured middleware for the given repo.","ref":"EctoMiddleware.html#middleware/3","title":"EctoMiddleware.middleware/3","type":"function"},{"doc":"Returns the configured middleware for the given repo, partitioning by whether or not the middleware is intended to run before or after the repo callback.","ref":"EctoMiddleware.html#partition_middleware/3","title":"EctoMiddleware.partition_middleware/3","type":"function"},{"doc":"","ref":"EctoMiddleware.html#t:action/0","title":"EctoMiddleware.action/0","type":"type"},{"doc":"","ref":"EctoMiddleware.html#t:middleware/0","title":"EctoMiddleware.middleware/0","type":"type"},{"doc":"","ref":"EctoMiddleware.html#t:resource/0","title":"EctoMiddleware.resource/0","type":"type"},{"doc":"Struct for holding middleware resolution data","ref":"EctoMiddleware.Resolution.html","title":"EctoMiddleware.Resolution","type":"module"},{"doc":"Executes all of the configured &quot;after&quot; middleware for the given resolution.This function is intended to be used by the EctoMiddleware module, but can also be used directly if you need to execute the &quot;after&quot; middleware for testing purposes.Provide a resolution struct as the argument with action, args, and entity fields, alongside the repo module that the middleware is being executed for, alongside the expected return value of the given Ecto.Repo callback.","ref":"EctoMiddleware.Resolution.html#execute_after!/2","title":"EctoMiddleware.Resolution.execute_after!/2","type":"function"},{"doc":"Executes all of the configured &quot;before&quot; middleware for the given resolution.This function is intended to be used by the EctoMiddleware module, but can also be used directly if you need to execute the &quot;before&quot; middleware for testing purposes.Provide a resolution struct as the argument with action, args, and entity fields, alongside the repo module that the middleware is being executed for.","ref":"EctoMiddleware.Resolution.html#execute_before!/1","title":"EctoMiddleware.Resolution.execute_before!/1","type":"function"},{"doc":"","ref":"EctoMiddleware.Resolution.html#new!/1","title":"EctoMiddleware.Resolution.new!/1","type":"macro"},{"doc":"","ref":"EctoMiddleware.Resolution.html#t:t/0","title":"EctoMiddleware.Resolution.t/0","type":"type"},{"doc":"Default middleware for Ecto repos.This middleware doesn't actually do anything; and is used largely to determine what middleware needs to run either before or after a given repo callback.See &amp;EctoMiddleware.partition_middleware/3 for more information.","ref":"EctoMiddleware.Super.html","title":"EctoMiddleware.Super","type":"module"}]